#include <errno.h>
#include <fcntl.h>
#include <netinet/ip.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#define __USE_GNU 1
#include <sys/socket.h>
#include <sys/types.h>
#include "NcPrintErr.h"
#include "NcSocket.h"

bool SocketOpenServer(uint16_t port, int * pSocket, struct sockaddr_in * pAddr)
{
	int s = socket( AF_INET, SOCK_STREAM, 0);
	if (s<0)
		return PrintErr("Failed to open socket. errno=%s", PrintErrNo(errno));
	fcntl( s, F_SETFL, O_NONBLOCK );
	*pSocket = s;
	int on = 1;
	setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));
	memset(pAddr, 0, sizeof(*pAddr));
	pAddr->sin_family = AF_INET;
	pAddr->sin_port  = htons(port);
	if (bind(s, (struct sockaddr*)pAddr, sizeof(*pAddr)) == -1)
		return PrintErr("Failed to bind socket to port %d. errno=%s", port, PrintErrNo(errno));
	if (listen(s, 20) == -1)
		return PrintErr("Failed to listen on socket. errno=%s", PrintErrNo(errno));
	return true;
}

bool SocketAcceptNonBlock(int listenSocket, int *pClient)
{
	*pClient = accept(listenSocket, NULL, NULL );
	if (*pClient<0)
		return false;
	fcntl( *pClient, F_SETFL, O_NONBLOCK );
	return true;
}

//struct sockaddr_in BuildAddressFromHostAndPort(const char* hostname, int port){
//	struct sockaddr_in ipa;
//	ipa.sin_family = AF_INET;
//	ipa.sin_port = htons(port);
//	struct hostent* host = gethostbyname(hostname);
//	if(!host)
//		return ipa;
//	char* addr = host->h_addr_list[0];
//	memcpy(&ipa.sin_addr.s_addr, addr, sizeof addr);
//	return ipa;
//}
//
