#include <errno.h>
#include <fcntl.h>
#include <poll.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "CtsTask.h"
#include "NcApi.h"
#include "NcPrintErr.h"
#include "Gpio.h"

extern CtsState g_cts;

extern "C"
{
void CtsMainGpio()
{
	struct pollfd pfd;
	char rdbuf[RDBUF_LEN];

	int pin = g_cts.config->getGpioPin();
	const char * p = GpioUnExport(pin);
	if (p==NULL) p = GpioExport(pin);
	if (p==NULL) p = GpioDirection(pin, "in");
	if (p==NULL) p = GpioTriggerMode(pin, "falling");
	if (p==NULL) p = GpioOpenValue(pin, &g_cts.gpioFd );
	if (p!=NULL)
	{
		printf("CtsMainGpio: %s\n", p);
		exit(EXIT_FAILURE);
		return;
	}

	int fd = g_cts.gpioFd;
	pfd.fd = fd;
	pfd.events=POLLPRI;

	while(1)
	{
		memset(rdbuf, 0, RDBUF_LEN);
		lseek(fd, 0, SEEK_SET);
		int ret = poll(&pfd, 1, -1);

		if(ret > 0)
		{
			NcApiCtsActive(0);
		}
		else if(ret<0)
		{
			perror("poll()");
			close(fd);
			break;
		}
		ret=read(fd, rdbuf, RDBUF_LEN-1);
	}
	printf("ERROR CTS!! \n\n");
}
}//extern C
