#ifndef RECV_ESSENTIALS_H_
#define RECV_ESSENTIALS_H_

#include "ConfigEssentials.h"

#if !_WIN32 && !_WIN64
#include <termios.h>
#include <netdb.h>
#include <vector>
#endif


#ifdef __cplusplus
extern "C"
{
#endif

typedef struct tRecvState
{
	int fd;
	tConfigEssentials * config_ser;
#if !_WIN32 && !_WIN64 // Exclude this when target is a Windows platform
	tRecvConfig * config;
	volatile TaskRunEnum state;
	int socketFd;
	struct sockaddr_in address;
	std::vector<int> clients;
#endif
} RecvState;

extern RecvState g_recv;

extern void RecvTaskInitEssentials(ConfigEssentials * c);

// NcApi specific methods
void UartReadCallback(uint8_t n, uint8_t * msg, uint8_t msgLength);
void UartHostAckCallback(uint8_t n, tNcApiHostAckNack * p);
void UartHostNAckCallback(uint8_t n, tNcApiHostAckNack * p);
void UartHostDataCallback(uint8_t n, tNcApiHostData * p);
void UartHostDataHapaCallback(uint8_t n, tNcApiHostDataHapa * p);
void UartHostUappDataCallback(uint8_t n, tNcApiHostUappData * p);
void UartHostUappDataHapaCallback(uint8_t n, tNcApiHostUappDataHapa * p);
void UartNodeInfoReplyCallback(uint8_t n, tNcApiNodeInfoReply * p);
void UartNeighborListReplyCallback(uint8_t n, tNcApiNeighborListReply * p);
void UartNetCmdReplyCallback(uint8_t n, tNcApiNetCmdReply * p);
void UartWesSetupRequestCallback(uint8_t n, tNcApiWesSetupRequest * p);
void UartWesStatusCallback(uint8_t n, tNcApiWesStatus * p);

#ifdef __cplusplus
}
#endif

#endif /* SEND_ESSENTIALS_H_ */
